import type { UIRouter } from '@uirouter/core';
import type { ComponentType, FunctionComponent } from 'react';
declare const connectWithRouter: <TRouterProps extends object, TNeedsProps extends object>(params?: (router: UIRouter, ownProps?: TNeedsProps | undefined) => TRouterProps, update?: boolean | ((parameters: TRouterProps) => Partial<TRouterProps>)) => <P extends TRouterProps>(WrappedComponent: ComponentType<P>) => FunctionComponent<Omit<P, keyof TRouterProps> & TNeedsProps>;
export default connectWithRouter;
