"use strict";
/*
    eslint-disable
    filenames/match-exported,
    unicorn/prevent-abbreviations
*/
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("@uirouter/react");
var react_2 = __importStar(require("react"));
var connectWithRouter = function (params, update) {
    if (params === void 0) { params = function (router, ownProps
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    ) {
        return __assign(__assign({}, ownProps), { router: router });
    }; }
    if (update === void 0) { update = false; }
    return function (WrappedComponent) {
        var ConnectedWithRouter = function (props) {
            var routerInstance = react_1.useRouter();
            var partialProps = react_2.useRef(params(routerInstance, props));
            if (update === true) {
                partialProps.current = params(routerInstance, props);
            }
            else if (update) {
                partialProps.current = __assign(__assign({}, partialProps.current), update(params(routerInstance, props)));
            }
            return (react_2.default.createElement(WrappedComponent, __assign({}, partialProps.current)));
        };
        return ConnectedWithRouter;
    };
};
exports.default = connectWithRouter;
//# sourceMappingURL=index.js.map